# sinopia-npm

auth plugin for [sinopia][sinopia] supporting an npm registry

[![build status][travis-badge]][travis-link]
[![npm version][npm-badge]][npm-link]
[![MIT license][license-badge]][license-link]
[![we're hiring][hiring-badge]][hiring-link]


## Usage

```
npm install sinopia
npm install sinopia-npm
```

## Configuration

Add to your sinopia `config.yaml`:

```yaml
auth:
  npm: true
```

You can pass more options using an object:

```yaml
auth:
  npm:
    registry: 'https://registry.npmjs.org'
    timeout: 1000
    registryConfig:
      userAgent: 'super/cool'
    cacheConfig:
      max: 1000
      maxAge: 900000 # 15 minutes
```

A full list of `registryConfig` options can be found in the [npm-registry-client README][npm-registry-client].
A full list of `cacheConfig` options can be found in the [lru-cache README][lru-cache].


## Contributing

Please follow our [Code of Conduct](https://github.com/goodeggs/sinopia-npm/blob/master/CODE_OF_CONDUCT.md)
when contributing to this project.

```
$ git clone https://github.com/goodeggs/sinopia-npm && cd sinopia-npm
$ npm install
$ npm test
```

_Module scaffold generated by [generator-goodeggs-npm](https://github.com/goodeggs/generator-goodeggs-npm)._

[sinopia]: https://github.com/rlidwka/sinopia
[npm-registry-client]: https://github.com/npm/npm-registry-client#configuration
[lru-cache]: https://github.com/isaacs/node-lru-cache#options

[travis-badge]: http://img.shields.io/travis/goodeggs/sinopia-npm.svg?style=flat-square
[travis-link]: https://travis-ci.org/goodeggs/sinopia-npm
[npm-badge]: http://img.shields.io/npm/v/sinopia-npm.svg?style=flat-square
[npm-link]: https://www.npmjs.org/package/sinopia-npm
[license-badge]: http://img.shields.io/badge/license-MIT-blue.svg?style=flat-square
[license-link]: LICENSE.md
[hiring-badge]: https://img.shields.io/badge/we're_hiring-yes-brightgreen.svg?style=flat-square
[hiring-link]: http://goodeggs.jobscore.com/?detail=Open+Source&sid=161
