// Generated by CoffeeScript 1.9.2
var LRU, RegClient, SinopiaNpm, _, ms;

RegClient = require('npm-registry-client');

LRU = require('lru-cache');

ms = require('to-ms');

_ = require('lodash');

SinopiaNpm = (function() {
  SinopiaNpm.prototype.sinopia_version = '1.1.0';

  function SinopiaNpm(arg) {
    var cacheConfig, ref, registryConfig;
    ref = arg != null ? arg : {}, this.client = ref.client, this.cache = ref.cache, this.timeout = ref.timeout, this.registry = ref.registry, registryConfig = ref.registryConfig, cacheConfig = ref.cacheConfig;
    if (this.client == null) {
      this.client = new RegClient(registryConfig);
    }
    if (this.cache == null) {
      this.cache = LRU(_.defaults({}, cacheConfig, {
        max: 1000,
        maxAge: ms.minutes(15)
      }));
    }
    if (this.timeout == null) {
      this.timeout = 1000;
    }
    if (this.registry == null) {
      this.registry = 'https://registry.npmjs.org';
    }
  }

  SinopiaNpm.prototype._getEmail = function(username, cb) {
    return this.client.get(this.registry + "/-/user/org.couchdb.user:" + (encodeURIComponent(username)), {
      timeout: this.timeout
    }, function(err, data) {
      if ((err != null ? err.code : void 0) === 'E404') {
        return cb();
      }
      if (err != null) {
        return cb(err);
      }
      return cb(null, data.email);
    });
  };

  SinopiaNpm.prototype.authenticate = function(username, password, cb) {
    if (this.cache.get("password-" + username) === password) {
      return process.nextTick(function() {
        return cb(null, [username]);
      });
    }
    return this._getEmail(username, (function(_this) {
      return function(err, email) {
        if (err != null) {
          return cb(err);
        }
        if (email == null) {
          return cb();
        }
        return _this.client.adduser(_this.registry, {
          auth: {
            username: username,
            password: password,
            email: email
          },
          timeout: _this.timeout
        }, function(err, data) {
          if ((err != null ? err.code : void 0) === 'E400') {
            return cb(null, false);
          }
          if (err != null) {
            return cb(err);
          }
          _this.cache.set("password-" + username, password);
          return cb(null, [username]);
        });
      };
    })(this));
  };

  SinopiaNpm.prototype.add_user = function(username, password, cb) {
    return this.authenticate(username, password, cb);
  };

  return SinopiaNpm;

})();

module.exports = SinopiaNpm;
